F-Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have
chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased. Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题意是 一个四位的素数,每次更改一位最终更改到另一个素数,并且更改的过程中的数也得是素数。

bfs  修改一位对每个符合条件的数枚举记录步数就好了

编译器竟然不识别万能头文件难过,itoa函数也不识别难过,搞得编译错误了好几次。。。。

#include<math.h>
#include<stdio.h>
#include<queue>
#include<string.h>
#include<stdlib.h>
using namespace std;
int vis[10005];
struct node
{
    int v,step;
};
int s,e;
bool isp(int x)
{
    for(int i=2;i<=(int)sqrt(double(x));i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;

}
int bfs(int s)
{
    node a,next;
    a.v=s; a.step=0;
    queue<node> q;
    q.push(a);
    vis[a.v]=1;
    while(!q.empty())
    {
        a=q.front();
        q.pop();
        if(a.v==e&&a.step!=0)
            return  a.step;
        char num[10];
        for(int i=0;i<4;i++)
        {
            sprintf(num,"%d",a.v);
           // itoa(a.v,num,10);
            for(char ch='0';ch<='9';ch++)
            {
                if((i==0||i==3)&&ch=='0')
                    continue;
                num[i]=ch;
                sscanf(num,"%d",&next.v);
                if(!vis[next.v]&&isp(next.v))
                {
                    next.step=a.step+1;
                    q.push(next);
                }
                vis[next.v]=1;
            }
        }
    }
    return 0;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&s,&e);
        int ans=bfs(s);
        printf("%d\n",ans);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值